---
id: sprint4
title: "Sprint 4: Finishing and Polishing Solution"
sidebar_label: Sprint 4
slug: /sprint4
---

### How is a machine deployed through Terrform in Azure?
--------------------------------------

The 4th sprint started later than anticipated by a week due to the delay by the company to secure a paid account for Azure.
In the meantime, to keep on track with the schedule **The Free Trail** version was used for the Azure account. With this occasion it was
**discovered** that a free trial can be **started per user account** of the organization and each user can have **their own free trial**,
making it a useful way **for a company to learn** how to use the Azure environment by creating subscriptions for a month for one
user/employee and then **inviting the rest** to use the account as co-administrators.

![img](../../static/img/thumbnail_Systemctl.jpg)
Figure 1 - Using systemctl to check status of service

--------------------------------

The **aim** of the final sprint was to **finish the minimal viable proof of concept** which was a running instance of Raven inside the
Azure environment hosted through the platform. This was harder to achieve than originally planned as the **process of configuring**
each part of the Raven services meant that the machine had to be first **configured in code**, **run-up manually**,  **checked if the
intended service was running** as intended and if not, the **logs had to be pulled** out and analyzed to determine why it failed.
Because the Terraform code was not complete a **GitLab pipeline implementation** for the Terraformed infrastructure was **not created**.

Therefore, a **manual process** was used for the deployment of the Terraform code which is described in the [Terraform](./terraform) page.
Some **useful commands** that were used to debug the status of the services were `journalctl -xfeu  [servicename].service` and
`systemctl status [servicename].service`. Before the provisioning even started the issues were that the Terraform Azure
provisioner has multiple resources for creating virtual machines. The one **initially used** to create the machine used a **deprecated version** for provisioning
the setup files for the machine.

![img](../../static/img/Journalctl.jpeg)
Figure 2 - Using journalctl -xfeu service to look at logs of machine

--------------------------------

Therefore, a switch had to be made to the **Linux virtual machine resource**.
On top of that, multiple little **tricks and quirks** of Terraform were **discovered**.
**Security Groups** need to be attached to the resource, normally the resource **does not attach** itself automatically if you reference it. You need to use a
**specific resource** just for attachment. When **destroying the environment** some components may **not be deleted** and have to be **checked
manually**, it seems the Terraform software is **not fully developed**. 

Because of the **large number of
variables and resources**, it becomes hard to **manage the cod**e in only one file and it’s **better to split it** up into multiple files.
Terraform will deploy all files with `.tf` extension. An **even better** way to split up the code is through
**modules**, but due to the time constraint, it was decided to **leave this as a suggestion** for future implementations.


Once this was discovered, different steps had to be taken to **ensure** that the **machines are reachable**. An obvious but quite easy-to-miss
the detail was that machines needed a **public IP** to be reached for connections. Because Azure uses **SSH for accessing the virtual machines**
created in its environment, the port used by SSH also **needs to be opened** from the start by allowing it in the Network Security Group. To ensure
that this is not a **safety issue**, the port should be **only available through a protected company VPN IP**. The known IP was
used as the ** only source ** that can access the machine through VPN. While the SSH port is open to the world, **strong private RSA keys** need to be
created either through the portal or locally used for the connection to **ensure protection**.

While **setting up** the initial Raven machine, **multiple insights** were gained about the services used, for example in the port
that needs to be open for the different services and hence the **network rules**. The exact rules and security groups created
are **at the company's disposal** in the **project repository**.

### What are the components outside of Raven that help it work?
--------------------------------------

While setting up Raven has proved to be a challenge in itself, due to the **amount of configuration** and **hard-to-find documentation**,
deploying Raven was not the only hurdle to overcome. Some **services needed external configuration** to ensure security and correct functioning.
Such services were **Azure Key Vault** and **Azure Endpoint**.

![img](../../static/img/vault-autounseal-2-cloud.png)
Figure 3 - How Azure Key Vault is used to store the unseal keys for Hashicorp Vault

--------------------------------------

Firstly, one of the services that are a component of Raven,  **Vault needed to be unsealed**. What this meant was that **Vault** was **deployed**
on the machine through the **provisioning script** but it **started locked**. Normally, the process of **unlocking is done manually** as there
are root tokens, passwords to unlock the Service given for further use. **A workaround** to this problem is using an **inbuilt function** of
Vault for deploying Vault instances through a **Cloud-based Key Vault** that **can store these initial values**.

Creating an Azure Key vault is quite a **complex process**. The permissions for the keys and who can access them need to be **well managed**. For
the purpose of the project **full permissions was given**, but a **best practice** would be to **allow only read, get, and list permissions**
for a **dedicated Service Principal** (application role).

Furthermore, for the scope of the project, an **additional machine** was made with **Vault preinstalled manually** as the automation of Vault
proved to be a much bigger challenge than originally anticipated and the dynamic elements of it represent a project of its own.

![img](../../static/img/MariaDbServer.png)
Figure 4 - Deployed MariaDB instance

---------------------------------------------

Another essential service was **MariaDB**. Originally this was meant to be **deployed on the same machin**e as the rest of the services
but the **more secure and easy to implement** solution was to use the premade service of **Azure MariaDB** which creates a MariaDB server
that comes with its **own endpoint and separate access list of IPs** which ensures a much **higher level of security**.  Because of its **own
access-list**, it needs to be **assigned the IP** of the machine that **runs portal-api manually**, and this is **only known after deployment**
or it should be a static IP from the start of the design which could be an issue.

### Putting it all together
-----------------------------------

The final step of the project was to **combine all the services** in order to run Raven portal-API as a service that will allow
the Raven portal to become accessible for **creating a demo version**.

As it can be seen in the picture Raven portal-API was started, but due to the **inbuilt nature** of the platform
design, **changes need to be made** in order to make Raven a truly **agnostic platform**. This aspect was mentioned to the development team and
acknowledged by them. It was agreed that those changes will be made in the near future.

![img](../../static/img/FrontDoorUse.png)
Figure 5 - Azure Front Door Use


One of the steps that need more work is the **implementation of the Frontend entry point**. This is used to **host the portal** while ensuring URL-path-based routing, health probing,
and an inbuilt firewall for SSL offloading. Finally, the **DNS needs to be manually configured** by editing the common origin communication policy and this will **allow requests** from the domain name
of DTACT, making it an **official component of their solution**.

### Conclusions
-----------------------------

**What where the major findings of the final sprint?**

Terraform sometimes does not work as intended. For example, after the manual deletion of some resources, the automation process does not work as advertised in the product documentation.
MariaDB is better deployed through its own Azure specialized resource rather than a custom-made MariaDB installed virtual machine, as it assures better security and better retention of data.
Vault needs a static IP address for its deployment and should have a separate access key than the root key, as that root key is not accepted by the Raven portal-API service.

**What more should be explored?**

While the project went in depth by exploring both the Azure environment and the Raven product and found a great amount of useful
security issues, configuration tips, and useful insights into the components that still need to be developed, there are still more avenues that
can be explored in the future.

One of them that was mentioned thought the project is RBAC user permission control. While the demo environment was used by only one person
throughout the project, once the company decides to fully expand to Azure it will have multiple developers changing and influencing the environment.
Therefore making sure that they do not have the permissions to tamper available machines, services and actions is a minimum required security standard, the aim is to keep the environment
as a "minimal access maximum security" solution.

**Can the Azure environment for Raven be fully automated?**

Raven can be fully automated but there are other external resources that need to be set beforehand.
In the actual Raven platform design DNS, storage, and database schema creation are external resources and, as stated before, need to be addressed as a different process.

